using System;
using System.Windows.Forms;
using System.Collections;

namespace MdiBaseSimple
{
	/// <summary>
	/// 
	/// </summary>
	public class MdiContext
	{
		protected MdiDoc MdiDoc;
		private Hashtable hashActive = new Hashtable();
		private Form mainForm;

		public MdiContext()
		{
			// 
			// TODO: Add constructor logic here
			//
		}

		public MdiView GetView(String key, Type type, Control container) 
		{
			foreach (Control control in container.Controls) 
			{
				MdiView view = control as MdiView;
				if (view != null && view.Name == key) 
				{
					return view;
				}
			}
			return null;
		}

		public MdiDoc CreateDocument(Type type)
		{
			Object[] args = new Object[]{this};
			Doc = (MdiDoc) Activator.CreateInstance (type, args);
			return Doc;
		}

		private MdiView CreateView(String name, Type type)
		{
			Object[] args = new Object[]{name, this};
			MdiView viewToCreate = (MdiView) Activator.CreateInstance (type, args);
			return viewToCreate;
		}

		public MdiView SetView(String strViewName, Type type, Control control) 
		{
			MdiBaseSimple.MdiView viewToSet = GetView(strViewName, type, control);
			if (viewToSet == null) 
			{
				viewToSet = CreateView(strViewName, type);
			}
			if (!control.Controls.Contains(viewToSet)) 
			{
				control.Controls.Add(viewToSet);
			}
			Control active = (Control) hashActive[control];
			if (active != null) active.Hide();
			hashActive[control] = viewToSet;
			viewToSet.Doc_Update(null);
			viewToSet.BringToFront();
			viewToSet.Show();
			return viewToSet;
		}

		public MdiView GetActiveView(Control container) 
		{
			return (MdiView) hashActive[container];
	    }

		public MdiDoc Doc
		{
			get
			{
				return MdiDoc;
			}
			set
			{
				MdiDoc = (MdiDoc) value; 
			}
		}

		public Form MainForm 
		{
			get {return mainForm;}
			set {mainForm = value;}
		}

	}
}
