//Copyright (C) 2000 Microsoft Corporation.  All rights reserved.

//This source code is intended only as a supplement to Microsoft
//Development Tools and/or on-line documentation.  See these other
//materials for detailed information regarding Microsoft code samples.

//THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
//KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
//IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
//PARTICULAR PURPOSE.
using System.Diagnostics;

namespace MdiBaseSimple
{
	using System;
	using System.IO ;
	using System.Drawing;
	using System.Drawing.Printing;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;

	/// <summary>
	///    Summary description for Form2.
	/// </summary>
	public class MdiView: Panel
	{
		/// <summary> 
		///    Required designer variable
		/// </summary>

		public MdiView() 
		{
			
		}

		public MdiView(String name, MdiContext context) : this()
		{
			m_context = context;
			Name = name;
			m_context.Doc.Update += new UpdateEvent(Doc_Update);
			this.Paint += new PaintEventHandler(MdiView_Paint);
			Hide();
		}

		private MdiContext m_context;
		public MdiContext Context 
		{
			get 
			{
				return m_context;
			}
		}

		//Override in derived class for actions to perform when doc changes
		public virtual void Doc_Update(Object sender)
		{
			Invalidate(true);
		}

		public virtual void MdiView_Paint(object sender, PaintEventArgs e)
		{
			//override in extended class for polymorphic painting
		}

		public virtual void MdiView_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			//override in extended class for polymorphic printing
		}
		
		public virtual void MdiView_QueryPageSettings(object sender, System.Drawing.Printing.QueryPageSettingsEventArgs e)
		{
			//override in extended class for polymorphic printing
		}

		public virtual void MdiView_BeginPrint(object sender, System.Drawing.Printing.PrintEventArgs e)
		{
			//override in extended class for polymorphic printing
		}

		public virtual void MdiView_EndPrint(object sender, System.Drawing.Printing.PrintEventArgs e)
		{
			//override in extended class for polymorphic printing
		}
	}
}
